﻿/**************************************************************************/
/*					  表紙／カバーのドキュメントを作成				  */
/*															 by お～まち  */
/*												2012.02.14  Version 0.81  */
/**************************************************************************/

//ドキュメントサイズのリスト
var paperSizeList = ["数値指定","レター", "リーガル", "タブロイド", "レター - ハーフ", "リーガル - ハーフ", 
"A5", "A4", "A3", "A2", "A1", "A0", "B6", "B5", "B4", "B3", "B2", "B1", "B0", 
"新書", "四六判", "はがき", "AB 判", "名刺 4 号", "名刺 3 号", "CD ジャケット"];
//単位のリスト
var unitNum = [2054188905, 2053729891, 2053991795, 2053336435, 1516790048, 1514238068];
var unitName = ["ポイント", "インチ", "ミリメートル", "センチメートル", "歯", "アメリカ式ポイント"];
var unitPoint = [1, 72, 2.834646, 28.34646, 0.7086614, 0.996094];
//単位のアプリケーションデフォルトの取得
defaultUnitName = 0;
for (i=0; i<unitNum.length; i++){
	if (app.viewPreferences.horizontalMeasurementUnits == unitNum[i]){
		defaultUnitName = i;
		break;
	}
}
//ダイアログ作成
var dlg = app.dialogs.add({name:"表紙／カバーのドキュメントを作成"});
var dlc = dlg.dialogColumns.add();
with(dlc.dialogRows.add()){ //1行目
	staticTexts.add({staticLabel:"長さの単位："});
	var dl1 = dropdowns.add({stringList:unitName, selectedIndex:defaultUnitName});
}
with(dlc.dialogRows.add()){ //2行目
	staticTexts.add({staticLabel:"ページサイズ："});
	var dl2 = dropdowns.add({stringList:paperSizeList, selectedIndex:0});
}
with(dlc.dialogRows.add()){ //3行目
	staticTexts.add({staticLabel:"数値指定時の左右："});
	var dl3 = realEditboxes.add({minWidth:80});
}
with(dlc.dialogRows.add()){ //4行目
	staticTexts.add({staticLabel:"数値指定時の天地："});
	var dl4 = realEditboxes.add({minWidth:80});
}
with(dlc.dialogRows.add()){ //5行目
	staticTexts.add({staticLabel:"背幅："});
	var dl5 = realEditboxes.add({minWidth:80});
}
with(dlc.dialogRows.add()){ //6行目
	var dl6 = enablingGroups.add({checkedState: false, staticLabel: "折り返しをつける"});
}
with(dl6.dialogColumns.add()){
	with(dialogRows.add()){ //7行目
		staticTexts.add({staticLabel:"折り返し幅："});
		var dl7 = realEditboxes.add({minWidth:80});
	}
}
with(dlc.dialogRows.add()){ //8行目
	var dl8 = enablingGroups.add({checkedState: false, staticLabel: "背文字のテキストフレームを作成"});
}
with(dl8.dialogColumns.add()){
	with(dialogRows.add()){ //9行目
		staticTexts.add({staticLabel:"天マージン："});
		var dl9 = realEditboxes.add({minWidth:80});
	}
}
//ダイアログを表示、キャンセルなら終了
if (!dlg.show()){dlg.destroy(); exit();}
//ポイントに変換する係数--以下、計算はポイントで行う
var mu = unitPoint[dl1.selectedIndex];

//ドキュメントを作成
var doc = app.documents.add();
//単位をポイントに変更
doc.viewPreferences.horizontalMeasurementUnits = 2054188905; //ポイント
doc.viewPreferences.verticalMeasurementUnits = 2054188905; //ポイント
doc.documentPreferences.facingPages = true; //見開き
doc.documentPreferences.pageBinding = 1819570786; //左綴じ　1920232546 は右綴じ
//ドキュメントサイズの指定
if (dl2.selectedIndex == 0){
	doc.documentPreferences.pageWidth = dl3.editValue * mu;
	doc.documentPreferences.pageHeight = dl4.editValue * mu;
} else {
	doc.documentPreferences.pageSize = paperSizeList[dl2.selectedIndex];
}
//マージンの設定
doc.marginPreferences.top = 0;
doc.marginPreferences.bottom = 0;
doc.marginPreferences.left = 0;
doc.marginPreferences.right = 0;
doc.marginPreferences.columnCount = 1;
//レイアウト調整を有効にしないと背幅を変更したときに背文字のテキストフレームの大きさが変更されない
doc.layoutAdjustmentPreferences.enableLayoutAdjustment = true;
//選択スプレッドの移動を許可しない
doc.spreads[0].allowPageShuffle = false;
//新しくマスタースプレッドを作成（ドキュメントのマージン設定になる）して、それを1ページ目に適用
doc.pages[0].appliedMaster = doc.masterSpreads.add(1);
//A-マスターを削除
doc.masterSpreads[0].remove();
//背幅の変更
var se = doc.pages[0];
var w = doc.documentPreferences.pageWidth;
		//resizeメソッドがポイントでしか指定できないのが難点
		//第1引数が何なのか分かっていません
		//第3引数はADDING_CURRENT_DIMENSIONS_TO（現在のサイズの差分）
se.resize(1768844080, [0, 0], 1215264592, [dl5.editValue * mu - w, 0]);
//背文字のテキストフレームを作成
if (dl8.checkedState){
	var txf = se.textFrames.add();
	txf.strokeColor = doc.swatches[0];
	txf.geometricBounds = se.bounds;
	txf.parentStory.storyPreferences.frameType = 1417176692; //TEXT_FRAME_TYPE
	txf.parentStory.storyPreferences.storyOrientation = 1986359924; //VERTICAL
	txf.textFramePreferences.verticalJustification = 1667591796;//CENTER_ALIGN
	txf.textFramePreferences.insetSpacing = [dl9.editValue * mu, 0, 0, 0];
	txf.contents = "ここに背文字が入ります"
}
//ドキュメントのページ数を設定
var pageCount = 3;
if (dl6.checkedState) pageCount = 5;
doc.documentPreferences.pagesPerDocument = pageCount;
//2ページ目を背のページの左にくっつける 1650812527=BEFORE, 1818584692=LEFT_ALIGN
doc.pages[1].move(1650812527, se, 1818584692);
//3ページ目を背のページの右にくっつける 1634104421=AFTER, 1919379572=RIGHT_ALIGN
doc.pages[2].move(1634104421, se, 1919379572);

if (pageCount == 5){
	w = dl7.editValue * mu - w;
	doc.pages[3].resize(1768844080, [0,0], 1215264592, [w ,0]);
	doc.pages[3].move(1650812527, doc.pages[0], 1818584692); //左にくっつける
	doc.pages[4].resize(1768844080, [0,0],1215264592,[w, 0]);
	doc.pages[4].move(1634104421, doc.pages[3], 1919379572); //右にくっつける
}

//単位を指定したものに変更
doc.viewPreferences.horizontalMeasurementUnits = unitNum[dl1.selectedIndex];
doc.viewPreferences.verticalMeasurementUnits = unitNum[dl1.selectedIndex];
//ドキュメントの作成ここまで
//ダイアログの解放
dlg.destroy();
//マスターページが表示されているので、通常ページを表示する
doc.layoutWindows[0].activeSpread = doc.spreads[0];
doc.layoutWindows[0].zoom(2053534835); //スプレッド全体
